---
title: "Personalized Coaching and Mentorship"
description: "Are you having trouble organizing your knowledge or making concrete decisions about priorities and solving challenges? I might be able to help."
showTableofContents: true
showTaxonomies: false
showRelated: false
---
{{< lead >}} Life is complicated. Your notes don't have to be.{{< /lead >}}

## Why should you trust me?
I've got [~20 years experience](/resume.pdf) in software engineering and system administration, roles which call for attention to detail, the ability to recall and synthesize information in novel ways, as well as identifying problems and breaking them down into specific actionable goals. Effective note-taking is much the same: notes are tools that you create to make some part of your life better. Sometimes the problems they solve are foreseen and sometimes they surprise you.

Effective software and effective note-taking systems both combine interactive human input with "stored" data to offer a solution to some problem in a person or organization's life.

## How can I help you?
### The Short List
What kind of mentorship can I offer?
- Programming
    - Python
    - Golang
- Note-taking
    - For concrete technical advice, most of my experience is with [Obsidian.md](https://obsidian.md)
    - General philosophy ( see below )
- Website development and hosting
- Career advice in software development and system administration

### Analysis Paralysis
Knowledge management presents an almost endless ocean of possible solutions. Being able to [rubber-duck](https://en.wikipedia.org/wiki/Rubber_duck_debugging) your problems with someone who can offer concrete guidance on tools that can solve them will let you move from "I don't know where to start" to "It works, how can I improve it even more?"

### Prioritize Goals
Together, we'll work to identify what you care about and and pick a solution that achieves a reasonable balance between efficacy and the cost of implementation/maintenance; if you spend more time per week "cleaning up your notes" than using them, your notes are not benefitting you.

### Create a flexible system
I'll work with you to create a system that allows for *iterative* evolution by minimizing the complexity and labor required to keep your notes useful. Life changes and we are ill-served by refusing to change with it. The notes you need today may not be useful tomorrow and vice-versa. My methodology emphasizes setting concrete goals for each note. This allows you to confidently measure when a note is "done" or at least "good enough for now".

### Support
Each one-on-one session includes an optional and complimentary 30 minute followup session. If you have more questions or feel like our original solution isn't a proper fit, I'll work with you to iterate and adapt it accordingly.

## Pricing
| Duration | Price |
| --- | --- |
| 1 Hour | 75$ USD |
| 2 Hours | 150$ USD |

## Booking
You can [book an appointment](https://short.ndumas.com/booking) via Calendly. Please note that payment is taken up-front during the booking process.

## Refunds, Rescheduling, and Cancellation
### Rescheduling 
If you wish to reschedule, please reach out to nickdumascoaching@proton.me **at least 24 hours before our session is scheduled** and I'll provide a link to a booking form that will let you set a new appointment at no additional cost.

### Refunds and Cancellation
Any refunds must be requested at least **24 hours before our session is scheduled**. 